

// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!                                                         !! 
// !!  Default is FALSE for all debug and manipulate options. !!
// !!                                                         !!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


// ************************************************************
//               ----   File structure  ----
// Note that the user can override these standard directories
// by specifying a full path.
// GIFDIR is where screen dumps are saved
// WAVDIR is where output audio files are saved
// RAWDIR is where input raw data files are saved
#if OSNUM == OS_FLAG_LINUX
#define GIFDIR "/home/linrad_data/"
#define WAVDIR "/home/linrad_data/"
#define RAWDIR "/home/linrad_data/"
#endif

#if OSNUM == OS_FLAG_WINDOWS
#define GIFDIR "C:\\linrad_data\\"
#define WAVDIR "C:\\linrad_data\\"
#define RAWDIR "C:\\linrad_data\\"
#endif
// ************************************************************
//               ----   Configuration   ----
// The coherent graph which also contains the S-meter is rectangular
// and it is set to a multiple of the font width in size.
// The side length will affect the number of digits for the S-meter
// and the screen space used for this window
#define COH_SIDE 7
// ************************************************************
//                ----  Debug tool  ----
// Set DUMPFILE to TRUE to get debug info in the file dmp.
// Use xz("string"); to get traces from code execution
// or make explicit writes to dmp. xz() will call
// fflush() and sync() and thus it contains information
// just before a crash that would otherwise not have been 
// physically written to the disk. 
// If you trace crashes, use fprintf(dmp,"%d.....",variables)
// followed by xz(" "); to physically write to disk.
// (Do not use xz() if you want fast processing)

//#define DUMPFILE TRUE
#define DUMPFILE FALSE
// ************************************************************
//                ----  Debug tool  ----
// Linrad can display thread activities on the top of the screen.
// This option causes a high system load under X11 and Windows
// because it causes frequent screen updates.
// Thread numbers are defined in thrdef.h and the info is written
// to the top of the screen.
// Use shift F1 to find the PIDs for Linrad thread numbers.
// Whenever a thread is not waiting on a semaphore or a blocking
// read or write a line is shown under the corresponding thread
// number. It does not necessarily mean it is consuming cpu time,
// it could be waitinf for some information from another thread.
// Under Linux, use top to find cpu load from different PIDs
//#define SHOW_THREAD_ACTIVE TRUE
#define SHOW_THREAD_ACTIVE FALSE
// *************************************************************
//        ---- manipulate calibration data ----
// Extract a calibration file from save files in Linrads .raw format
// and save them as the appropriate dsp_xxx_corr file.
//#define SAVE_RAWFILE_CORR TRUE
#define SAVE_RAWFILE_CORR FALSE
// *************************************************************
//        ---- manipulate calibration data ----
// Extract a calibration file from save files in Linrads .raw format
// and save them as the appropriate dsp_xxx_corr file.
//#define SAVE_RAWFILE_IQCORR TRUE
#define SAVE_RAWFILE_IQCORR FALSE
// *************************************************************
//        ---- manipulate calibration data ----
// Use calibration data from the appropriate dsp_xx_corr file
// and disregard whatever data that is contained in the
// calibration file.
//#define DISREGARD_RAWFILE_CORR TRUE
#define DISREGARD_RAWFILE_CORR FALSE
// **************************************************************
//        ---- manipulate calibration data ----
// Skip the mirror image calibration that is present in a .raw file.
//#define DISREGARD_RAWFILE_IQCORR TRUE
#define DISREGARD_RAWFILE_IQCORR FALSE
// ************************************************************
//                ----  Debug tool  ----
// Linrad can display buffer usage as bars on screen when "T"
// is pressed to provide timing info. This option is however
// rather time-consuming and not often helpful 
//#define BUFBARS TRUE
#define BUFBARS FALSE
// ************************************************************
// ************************************************************
// ************************************************************
// Defines that depend on options. No need to change  below this line.
#if SHOW_THREAD_ACTIVE==TRUE
void show_thread_on(int thrno);
void show_thread_off(int thrno);
#endif  
